//+------------------------------------------------------------------
//|                                                             stpmt
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     DeepSkyBlue
#property indicator_color2     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    Smooth            = 9;
extern bool   UseGraphATFormula = false;
extern double LevelUp           = 60;
extern double LevelDown         = 40;

//
//
//
//
//

double stpmt[];
double stpmtSma[];
double stpmtUp[];
double stpmtDn[];
double upBound;
double dnBound;


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,stpmt);
   SetIndexBuffer(1,stpmtSma);
   SetIndexBuffer(2,stpmtUp); SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,stpmtDn); SetIndexStyle(3,DRAW_NONE);

      //
      //
      //
      //
      //
         
      string name;
      if (UseGraphATFormula)
            { name = "formula 2"; upBound=50;  dnBound=-50; SetLevelValue(0,LevelUp-50); SetLevelValue(1,LevelDown-50); }
      else  { name = "formula 1"; upBound=100; dnBound=  0; SetLevelValue(0,LevelUp);    SetLevelValue(1,LevelDown); }
      IndicatorShortName("stpmt "+name+" ("+Smooth+")");
   return(0);
}
int deinit(){ return(0); }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double work[][8];
#define _stochk1 0
#define _stochk2 1
#define _stochk3 2
#define _stochk4 3
#define _stochs1 4
#define _stochs2 5
#define _stochs3 6
#define _stochs4 7

//
//
//
//
//

int start()
{
   double max,min;
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      min = Low[ArrayMinimum(Low,5,i)];
      max = High[ArrayMaximum(High,5,i)];
         if (min!=max)
               work[r][_stochk1] = stochSma(100.0*(Close[i]-min)/(max-min),3,i,0);
         else  work[r][_stochk1] = stochSma(0                             ,3,i,0);
         
      min = Low[ArrayMinimum(Low,14,i)];
      max = High[ArrayMaximum(High,14,i)];
         if (min!=max)
               work[r][_stochk2] = stochSma(100.0*(Close[i]-min)/(max-min),3,i,1);
         else  work[r][_stochk2] = stochSma(0                             ,3,i,1);
         
      min = Low[ArrayMinimum(Low,45,i)];
      max = High[ArrayMaximum(High,45,i)];
         if (min!=max)
               work[r][_stochk3] = stochSma(100.0*(Close[i]-min)/(max-min),14,i,2);
         else  work[r][_stochk3] = stochSma(0                             ,14,i,2);

      min = Low[ArrayMinimum(Low,75,i)];
      max = High[ArrayMaximum(High,75,i)];
         if (min!=max)
               work[r][_stochk4] = stochSma(100.0*(Close[i]-min)/(max-min),20,i,3);
         else  work[r][_stochk4] = stochSma(0                             ,20,i,3);
         
      //
      //
      //
      //
      //

         if (UseGraphATFormula)
         {
               work[r][_stochs1] = stochSma(work[r][_stochk1],3,i,4);
               work[r][_stochs2] = stochSma(work[r][_stochk2],3,i,5);
               work[r][_stochs3] = stochSma(work[r][_stochk3],3,i,6);
               work[r][_stochs4] = stochSma(work[r][_stochk4],3,i,7);
               double sm       = (5.0*work[r][_stochs1]+3.0*work[r][_stochs2]+2.0*work[r][_stochs3]+3.0*work[r][_stochs4])/13.0; 
                      stpmt[i] = sm-stochSma(sm,68,i,8);
         }
         else stpmt[i] = (4.1*work[r][_stochk1]+2.5*work[r][_stochk2]+work[r][_stochk3]+4.0*work[r][_stochk4])/11.6;
      
      //
      //
      //
      //
      //
      
      stpmtSma[i] = stochSma(stpmt[i],Smooth,i,9);
      stpmtUp[i]  = upBound;
      stpmtDn[i]  = dnBound;
   }
   return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workSma[][10];
double stochSma(double rawStoch, double period, int i, int forInstance)
{
   if (ArrayRange(workSma,0)!=Bars) ArrayResize(workSma,Bars);

   //
   //
   //
   //
   //
      
   int r = Bars-i-1;
      workSma[r][forInstance] = rawStoch;
   double sum = 0; for (int k=0; k<period && (r-k)>=0; k++) sum += workSma[r-k][forInstance];
   return(sum/MathMax(1.0,period));
}